package com.bbyb.operating.examination.model.po;

import com.baomidou.mybatisplus.annotation.*;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "user")
public class User {

    @TableId(value = "id", type = IdType.AUTO) // 自增主键
    private Integer id;

    @TableField(value = "user_code") // 用户编码
    private String userCode;

    @TableField(value = "user_name") // 用户名称
    private String userName;

    @TableField(value = "phone") // 手机号
    private String phone;

    @TableField(value = "password") // 密码
    private String password;

    @TableField(value = "email") // 邮箱
    private String email;

    @TableField(value = "id_card") // 身份证号
    private String idCard;

    @TableField(value = "gender", fill = FieldFill.INSERT) // 性别（1 男 2 女）
    private Integer gender;

    @TableField(value = "is_admin", fill = FieldFill.INSERT) // 是否超级管理员（0 否 1 是）
    private Integer isAdmin;

    @TableField(value = "is_enable", fill = FieldFill.INSERT) // 是否启用（0 启用 1 禁用）
    private Integer isEnable;

    @TableField(value = "create_by") // 创建人
    private String createBy;

    @TableField(value = "create_time", fill = FieldFill.INSERT) // 创建时间
    private LocalDateTime createTime;

    @TableField(value = "update_by") // 更新人
    private String updateBy;

    @TableField(value = "update_time", fill = FieldFill.INSERT_UPDATE) // 更新时间
    private LocalDateTime updateTime;

    @TableField(value = "invalid", fill = FieldFill.INSERT) // 数据是否作废（0 正常 1 作废）
    private Integer invalid;

    public static User buildUser(UserReq userReq) {
        return User.builder()
                .userCode(userReq.getUserCode())
                .userName(userReq.getUserName())
                .phone(userReq.getPhone())
                .password(userReq.getPassword())
                .email(userReq.getEmail())
                .idCard(userReq.getIdCard())
                .gender(userReq.getGender())
                .isAdmin(userReq.getIsAdmin())
                .isEnable(userReq.getIsEnable())
                .createBy(userReq.getCreateBy())
                .createTime(userReq.getCreateTime()) // 注意这里的时间转换可能需要处理
                .updateBy(userReq.getUpdateBy())
                .updateTime(userReq.getUpdateTime()) // 同样，这里的时间转换也需要考虑
                .invalid(userReq.getInvalid())
                .build();
    }
}
